/*!
 * Copyright (c) 2023 Eclipse Foundation, Inc.
 * 
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 * 
 * Contributors:
 *   Olivier Goulet <olivier.goulet@eclipse-foundation.org>
 * 
 * SPDX-License-Identifier: EPL-2.0
*/

@import (reference) '../styles.less';
@import url('https://fonts.googleapis.com/css2?family=Silkscreen&display=swap');

//== Base

// Defaults
body {
  overflow-x: hidden;
}

// Color Palette
@brand-primary: #ed0d90;
@american-purple: #470457;
@deep-violet: #2c0353;
@ksu-purple: #592481;

// Color Backgrounds
.bg-american-purple {
  background-color: @american-purple;
}

.bg-deep-violet {
  background-color: @deep-violet;
}

.bg-ksu-purple {
  background-color: @ksu-purple;
}

// Typography
main {
  &,
  & .dark {
    h1,
    .h1,
    h2,
    .h2,
    h3,
    .h3 { 
      color: @brand-primary;
      font-family: 'Roboto', sans-serif;
    }
  }

  & .dark {
    h3,
    .h3 {
      color: @white;
    }
  }

  ul li {
    line-height: 2.5;
  }
}

main h3, // @todo: Move this rule to styles.less
main .h3 {
  font-weight: 500;  
}

main .landing-page {
  text-align: center;
}

//== Layout

// Jumbotron
@jumbotron-height: calc(100vh - 120px - 33px); // Subtract header height

.header-wrapper .featured-jumbotron {
  overflow: hidden;
  padding: 0;
  min-height: unset;
  background: linear-gradient(180deg, @deep-violet, darken(@brand-primary, 30%) 60%, darken(@brand-primary, 30%) 80%, @deep-violet);
}

.header-wrapper.sdv-hackathon-2023-landing-page .featured-jumbotron {
  background: url('../images/pages/sdv-hackathon-2023/featured-jumbotron-bg.jpg');
  background-repeat: no-repeat;
  background-size: cover;
  background-position: center;
}

.featured-jumbotron h1,
.featured-jumbotron .h1 {
  justify-self: flex-start;
  text-align: center;
  font-size: 42px;
  font-family: 'Silkscreen', cursive;

  .highlight {
    color: @brand-primary;
  }
}

.custom-jumbotron-content-bg {
  display: none;
}

.custom-jumbotron-content-body {
  position: relative;
}

.custom-jumbotron-content {
  display: flex;
  flex-direction: column;
  padding-top: 4rem;
  padding-bottom: 4rem;
  filter: drop-shadow(0px 0px 5px 2px rgba(0, 0, 0, 0.2));

  &-body {
    padding-left: 4rem;
    padding-right: 4rem;
    text-align: center;

    p {
      font-size: 1.5rem;
    }
  }
}

.jumbotron-links .btn {
  margin-bottom: 0;  
}

@media (min-width: @screen-md-min) {
  .header-wrapper.sdv-hackathon-2023-landing-page .featured-jumbotron {
    height: @jumbotron-height;
    min-height: 90rem;
    max-height: unset;
    padding-bottom: 4rem;
    background: #1b0655;
  }

  .custom-jumbotron-content-bg {
    display: block;

    img {
      max-height: 20rem;
      margin: auto;
    }
  }

  .custom-jumbotron-content-body::before {
    content: '';
    position: absolute;
    left: calc(-1 * (100vw - 100%) / 2);
    z-index: -1;
    width: 100vw;
    height: 32rem;
    background: linear-gradient(180deg, rgba(0, 0, 0, 0), fade(@brand-primary, 30%), fade(brown, 30%), rgba(0, 0, 0, 0));
  }

  .custom-jumbotron-content {
    justify-content: space-between;
    height: calc(@jumbotron-height - 10rem);

    &-body p {
      font-size: 2.3rem;
    }

    .jumbotron-subtitle {
      font-size: 3rem;
    }

    .jumbotron-text {
      font-size: 2rem;
    }
  }
}

@media (max-width: @screen-md-max) {
  .jumbotron-custom:after {
    z-index: -1;
  }
}

@media (min-width: 1200px) {
  h1,
  .h1 {
    font-size: 55px;
  }

  .custom-jumbotron-content-bg img {
    max-height: unset;
  }
}

// Sub Nav
.subnav {
  display: none;
}

@media (min-width: @screen-md-min) {
  .subnav {
    display: block;
    width: 100vw;
    padding: 2rem 0;
    margin: 0 calc(50% - 50vw);
    background-color: @brand-primary;
    border-color: @brand-primary;

    ul {
      display: flex;
      justify-content: center;
      align-items: center;
      gap: 4rem;
      width: 100%;
      margin: 0;
      padding-right: 12rem; // Offset to center under nav
    }

    .btn {
      min-width: 15rem;
    }
  }
}

// Sections

.section-featured {
  font-weight: 500;
}

.section-lip {
  position: relative;
}

.section-lip::before {
  content: '';
  position: absolute;
  top: 0;
  left: calc(50% - 12rem);
  z-index: 2;
  width: 24rem;
  height: 2rem;
  background-color: #4dcbf3;
}

//== Components

// Buttons
.btn-neutral {
  .button-variant(@brand-secondary, @white, @white);

  &:link,
  &:visited,
  &:active,
  &:hover {
    color: @black;
  }
}

// Icon Item
.icon-item {
  text-transform: uppercase;

  .icon-item-container {
    display: flex;
    align-items: flex-end;
    min-height: 12rem;
    margin-bottom: 2rem; 
  }
  .icon-item-container img {
    margin: 0 auto;
    height: 100%; // Required for Mobile Safari
  }
}

// User Display
.eclipsefdn-user-display {
  img {
    border-radius: 50%;
  }

  h3 > a,
  .h3 > a {
    &,
    &:link,
    &:visited,
    &:hover,
    &:active {
      color: @brand-primary;
    }
  }
}

// Schedule Table
#schedule{
  overflow-x: auto;
}

.schedule-table {  
  margin: auto;
  max-width: 68rem;
  border: 2px solid #fca6e3;
  border-collapse: separate;
  border-radius: 1rem;

  td,
  th {
    padding: 1rem 2rem;
  }

  tr > th {
    border-right: 1px solid #fca6e3;
    border-bottom: 1px solid #fca6e3;
    color: #fca6e3;
  }

  tr > td {
    border-right: 1px solid #ddd;
    border-bottom: 1px solid #ddd;
  }

  tr > th,
  tr > td {
    border-top: none;
  }

  tr:first-child > th {
    border-bottom: 1px solid #fca6e3;
    border-right: 1px solid #fca6e3;
  }

  tr:last-child > td,
  tr:last-child > th {
    border-bottom: none;
  }

  tr > td:last-child,
  tr > th:last-child {
    border-right: none;
  }
}

// Wired Circle
@media (min-width: @screen-md-min) {
  .wired-circle {
    position: absolute;
    width: 20rem;
    height: 20rem;
    background: url('../images/pages/sdv-hackathon-2023/wired-circle.webp');
    background-size: contain;
  }
}

//== Page Sections

.hack-challenges-section {
  .card ul li {
    line-height: unset;
  }
}

.additional-info-section,
.rules-section {
  position: relative;

  .column-start,
  .column-end {
    display: flex;
    flex-direction: column;
  }

  .column-start {
    align-content: flex-end;
  }

  .column-end {
    align-content: flex-start;
  }

  @media (min-width: @screen-md-min) {
    .column-start,
    .column-end {
      & > .container-fluid {
        max-width: 640px;
      }
    }
  }
}

.rules-section {
  position: relative;

  .column-start {
    padding-top: 16rem;
  }
  
  .column-end {
    padding-top: 6rem;
  }

  .column-start,
  .column-end {
    padding-bottom: 6rem;

    .container-fluid {
      z-index: 2;
    }
  }

  @media (min-width: @screen-md-min) {
    .column-start,
    .column-end {
      padding-top: 16rem;
      padding-bottom: 6rem;
    }
  }

  h2 {
    position: absolute;
    z-index: 2;
    width: 100%;
    margin: 8rem auto;
    text-align: center;
  }
}

.hack-mcs-section {
  h2,
  .h2 {
    // Need to lowercase the 's' in 'MCs' for readability
    text-transform: none;
  }
}

.venue-and-location-section {
  position: relative;
  &.dark h2,
  .h2 {
    color: @white;
  }

  &.dark .venue-and-location {
    h2,
    .h2,
    p {
      filter: drop-shadow(0px 0px 5px rgba(0, 0, 0, 0.6));
    }
  }

  .venue-and-location-section-bg-container {
    position: absolute;
    top: 0;
    left: 0;
    z-index: -1;
    width: 100%;
    height: 100%;
    overflow: hidden;
  }

  .venue-and-location-section-bg {
    position: absolute;
    width: 100%;
    height: 100%;
    background: url('../images/pages/sdv-hackathon-2023/venue-and-location-bg.jpg');
    background-repeat: no-repeat;
    background-size: cover;
    background-position: center;
    background-position: center 45%;
  }

  .venue-and-location-address {
    font-size: 2.4rem;
  }

  @media (min-width: @screen-sm-min) {
    .venue-and-location-address {
      margin-top: 12rem;
    }

    .venue-and-location-section-bg {
      transform: scale(1.5);
      filter: blur(4px);
    }
  }
}

// Wired Circle modifications per section
@media (min-width: @screen-md-min) {
  .about-section .wired-circle {
    display: none;
  }
  
  .additional-info-section .wired-circle {
    top: calc(50% - 10rem);
    left: calc(50% - 10rem + 0.1rem);
  }

  .rules-section .wired-circle {
    top: calc(50% - 10rem);
    left: -10rem;
  }
}

@media (min-width: @screen-lg-min) {
  .about-section .wired-circle {
    display: block;
    top: calc(-10rem);
    right: -10rem;
    z-index: 1;
  }

  .rules-section .wired-circle {
    width: 30rem;
    height: 30rem;
    top: calc(50% - 15rem);
    left: -15rem;
  }
}

@media (min-width: 1600px) {
  .about-section .wired-circle {
    width: 50rem;
    height: 50rem;
    top: -10rem;
    left: unset;
    right: -25rem;
  }
}

//== Utilities

.text-primary {
  color: @brand-primary;
}

